# -*- coding: utf-8 -*-

# Copyright 2012 Canonical Ltd.
#
# This program is free software: you can redistribute it and/or modify it
# under the terms of the GNU General Public License version 3, as published
# by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranties of
# MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR
# PURPOSE.  See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along
# with this program.  If not, see <http://www.gnu.org/licenses/>.

"""Page to allow the user to login into Ubuntu One."""

import gettext

from PyQt4 import QtGui

from ubuntu_sso.qt.gui import SSOWizardPage


_ = gettext.gettext


class CurrentUserSignInPage(SSOWizardPage):
    """Wizard Page that lets a current user Sign into Ubuntu One."""

    # Invalid names of Qt-inherited methods
    # pylint: disable=C0103

    def nextId(self):
        """Provide the next id."""
        return self.next

    def initializePage(self):
        """Setup UI details."""
        self.setButtonText(QtGui.QWizard.CancelButton,
            _("Cancel"))
        # Layout without custom button 1,
        # without finish button
        self.wizard().setButtonLayout([
            QtGui.QWizard.BackButton,
            QtGui.QWizard.Stretch])

        # Set sign_in_button as default when the page is shown.
        self.ui.sign_in_button.setDefault(True)
        self.ui.sign_in_button.setEnabled(False)
        self.ui.sign_in_button.setProperty("DisabledState",
            not self.ui.sign_in_button.isEnabled())
        self.ui.sign_in_button.style().unpolish(
            self.ui.sign_in_button)
        self.ui.sign_in_button.style().polish(
            self.ui.sign_in_button)

    def cleanupPage(self):
        """Reset the state of the wizard if Verification code was visited."""
        self.wizard()._next_id = None
