# -*- coding: utf-8 -*-

# Copyright 2012 Canonical Ltd.
#
# This program is free software: you can redistribute it and/or modify it
# under the terms of the GNU General Public License version 3, as published
# by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranties of
# MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR
# PURPOSE.  See the GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along
# with this program.  If not, see <http://www.gnu.org/licenses/>.

"""Page to allow the user to sign in."""

import gettext

from PyQt4 import QtGui

from ubuntu_sso.qt.gui import SSOWizardPage


_ = gettext.gettext


class SignInPage(SSOWizardPage):
    """Wizard Page that lets the user Sign into Ubuntu One."""

    def __init__(self, image_pixmap, *args, **kwargs):
        super(SignInPage, self).__init__(*args, **kwargs)
        self.ui.image_label.setPixmap(image_pixmap)

    # Invalid names of Qt-inherited methods
    # pylint: disable=C0103

    def initializePage(self):
        """Setup UI details."""
        self.ui.cancel_button.setText(_("Close window and setup later"))
        self.ui.cancel_button.clicked.connect(self.wizard().reject)
        # Layout without custom button 1,
        # without finish button
        # without cancel
        self.wizard().setButtonLayout([
            QtGui.QWizard.Stretch,
            QtGui.QWizard.NextButton])

    def showEvent(self, event):
        """Set existing_account_button as default when the page is shown."""
        super(SignInPage, self).showEvent(event)
        self.ui.existing_account_button.setDefault(True)
        self.ui.existing_account_button.style().unpolish(
            self.ui.existing_account_button)
        self.ui.existing_account_button.style().polish(
            self.ui.existing_account_button)

    def nextId(self):
        """Provide the next id."""
        return self.next
